/*
 * Created on 2004/08/17
 *
 */
package jnet.hirommy.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.ImageIcon;
import javax.swing.JFrame;

import jnet.hirommy.util.HirommyInfoConst;

/**
 * This is visual class for "about hirommy project".
 * 
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class HirommyInfoWindow extends JFrame {
	
	public static final int WIDTH = 500;
	public static final int HEIGHT = 270;
	
	private static HirommyInfoWindow hirommyInfoWindow = new HirommyInfoWindow();
	
	private Image img;
	private static final int IMG_WIDTH = 150;
	private static final int IMG_HEIGHT = 200;
	
	private static final int TOP_INSET = 30;
	private static final int LEFT_INSET = 10;
	private static final int TOP_START = 40;
	
	/**
	 * This is a default constractor.
	 */
	private HirommyInfoWindow() {
		super(HirommyInfoConst.SOFTWARE_NAME);
		this.setBackground(Color.WHITE);
		this.setSize(WIDTH, HEIGHT);
		this.setResizable(false);
		this.setLocation((int)(Toolkit.getDefaultToolkit().getScreenSize().getWidth() - WIDTH) / 2,
						  (int)(Toolkit.getDefaultToolkit().getScreenSize().getHeight() - HEIGHT) / 2);
		this.addWindowListener(
				new WindowAdapter() {
					public void windowClosing(WindowEvent e) {
						HirommyInfoWindow.getInstance().setVisible(false);
					}
				}
			);
	}
	
	/**
	 * paint.
	 */
	public void paint(Graphics g) {
		super.paint(g);
		
		// set x, y on the origin 
		Insets is = getInsets();
		int x = (getWidth() - is.left - is.right ) / 2 + is.left;
		int y = (getHeight() - is.bottom - is.top) / 2;
		
		img = new ImageIcon("img/help.jpg").getImage();
		g.drawImage(img,
					LEFT_INSET,
					TOP_INSET,
					LEFT_INSET + IMG_WIDTH,
					TOP_INSET + IMG_HEIGHT,
					this);
		
		// draw cregit
		int delta = 17;
		int num = 0;
		Font fnt = new Font("scale", Font.PLAIN, 15);
		g.setFont(fnt);
		
		g.drawString("Hirommy Platform", LEFT_INSET * 3 + IMG_WIDTH, TOP_START + delta * num);
		num++;
		num++;
		g.drawString(HirommyInfoConst.VERSION, LEFT_INSET * 3 + IMG_WIDTH, TOP_START + delta * num);
		num++;
		num++;
		g.drawString("Copyright(c) Dnet lab. 2004. All Right Received.", LEFT_INSET * 3 + IMG_WIDTH, TOP_START + delta * num);
		num++;
		num++;
		g.drawString("URL  : http://www.jnet.densi.kansai-u.ac.jp/", LEFT_INSET * 3 + IMG_WIDTH, TOP_START + delta * num);
		num++;
		g.drawString("Mail : sakai@jnet.densi.kansai-u.ac.jp", LEFT_INSET * 3 + IMG_WIDTH, TOP_START + delta * num);
	}
	/**
	 * 
	 * @return instance of this class.
	 */
	public static HirommyInfoWindow getInstance() {
		return hirommyInfoWindow;
	}
}
