/*
 * Created on 2004/08/09
 *
 */
package jnet.hirommy.gui;

import javax.swing.JTabbedPane;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class MainTabPanel extends JTabbedPane {
	
	static final int HEIGHT = MainWindow.HEIGHT;
	static final int WIDTH = MainWindow.WIDTH;
	
	private FileManagerTabPanel fileManagerTabPanel = null;
	private SetUpTabPanel setUpTabPanel = null;
	private SimulationTabPanel simulationTabPanel = null;
	private ViewerTabPanel viewerTabPanel = null;
	private UtilityPanel utilityPanel = null;
	/**
	 * This is the default constructor
	 */
	public MainTabPanel() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		this.setSize(WIDTH, HEIGHT);
		this.setBackground(new java.awt.Color(204,204,204));
		this.setSize(WIDTH, HEIGHT);
		this.addTab("Viewer", null, getViewerTabPanel(), null);
		this.addTab("FileManeger", null, getFileManagerTabPanel(), null);
		this.addTab("Simulation", null, getSimulationTabPanel(), null);
		this.addTab("Utility", null, getUtilityPanel(), null);
		this.addTab("SetUp", null, getSetUpTabPanel(), null);
	}
	/**
	 * This method initializes fileManagerTabPanel	
	 * 	
	 * @return jnet.hirommy.gui.FileManagerTabPanel	
	 */    
	private FileManagerTabPanel getFileManagerTabPanel() {
		if (fileManagerTabPanel == null) {
			fileManagerTabPanel = new FileManagerTabPanel();
		}
		return fileManagerTabPanel;
	}
	/**
	 * This method initializes setUpTabPanel	
	 * 	
	 * @return jnet.hirommy.gui.SetUpTabPanel	
	 */    
	private SetUpTabPanel getSetUpTabPanel() {
		if (setUpTabPanel == null) {
			setUpTabPanel = new SetUpTabPanel();
		}
		return setUpTabPanel;
	}
	/**
	 * This method initializes simulationTabPanel	
	 * 	
	 * @return jnet.hirommy.gui.SimulationTabPanel	
	 */    
	private SimulationTabPanel getSimulationTabPanel() {
		if (simulationTabPanel == null) {
			simulationTabPanel = new SimulationTabPanel();
			simulationTabPanel.addFocusListener(new java.awt.event.FocusAdapter() { 
				public void focusGained(java.awt.event.FocusEvent e) {
					// TODO cording
					ViewerControlComponentsManager vm = new ViewerControlComponentsManager();
					vm.setSimulationMode(true);
				}
			});
		}
		return simulationTabPanel;
	}
	/**
	 * This method initializes viewerTabPanel	
	 * 	
	 * @return jnet.hirommy.gui.ViewerTabPanel	
	 */    
	private ViewerTabPanel getViewerTabPanel() {
		if (viewerTabPanel == null) {
			viewerTabPanel = new ViewerTabPanel();
			viewerTabPanel.addFocusListener(new java.awt.event.FocusAdapter() { 
				public void focusGained(java.awt.event.FocusEvent e) {    
					// TODO cording
					ViewerControlComponentsManager vm = new ViewerControlComponentsManager();
					vm.setSimulationMode(false);
				}
			});
		}
		return viewerTabPanel;
	}
	/**
	 * This method initializes utilityPanel	
	 * 	
	 * @return jnet.hirommy.gui.UtilityPanel	
	 */    
	private UtilityPanel getUtilityPanel() {
		if (utilityPanel == null) {
			utilityPanel = new UtilityPanel();
		}
		return utilityPanel;
	}
  }  //  @jve:decl-index=0:visual-constraint="10,10"
