/*
 * Created on 2004/08/09
 *
 */
package jnet.hirommy.gui;

import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;

import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import jnet.hirommy.util.HirommyInfoConst;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class MainWindow extends JFrame {
	
	public static final int HEIGHT = 768;
	public static final int WIDTH = 1024;
	
	private javax.swing.JPanel jContentPane = null;

	private MainTabPanel mainTabPane = null;
	private JMenuBar jJMenuBar = null;
	private JMenu jMenu = null;
	private JMenu jMenu1 = null;
	private JMenu jMenu2 = null;
	private JMenuItem jMenuItem = null;
	private JMenuItem jMenuItem1 = null;
	/**
	 * This is the default constructor
	 */
	public MainWindow() {
		super(HirommyInfoConst.SOFTWARE_NAME);
		this.setLocation((int)(Toolkit.getDefaultToolkit().getScreenSize().getWidth() - WIDTH) / 2,
						  (int)(Toolkit.getDefaultToolkit().getScreenSize().getHeight() - HEIGHT) / 2);
		this.addWindowListener(
				new WindowAdapter() {
					public void windowClosing(WindowEvent e) {
						System.exit(0);
					}
				}
			);
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setBackground(new java.awt.Color(204,204,204));
		this.setSize(WIDTH,HEIGHT);
		this.setResizable(false);
		this.setContentPane(getJContentPane());
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.setBackground(new java.awt.Color(204,204,204));
			jContentPane.add(getMainTabPane(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getJJMenuBar(), java.awt.BorderLayout.NORTH);
		}
		return jContentPane;
	}
	/**
	 * This method initializes mainTabPane	
	 * 	
	 * @return jnet.hirommy.gui.MainTabPane	
	 */    
	private MainTabPanel getMainTabPane() {
		if (mainTabPane == null) {
			mainTabPane = new MainTabPanel();
			mainTabPane.setBackground(new java.awt.Color(204,204,204));
		}
		return mainTabPane;
	}
	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */    
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.setBackground(new java.awt.Color(204,204,204));
			jJMenuBar.add(getJMenu());
			jJMenuBar.add(getJMenu1());
			jJMenuBar.add(getJMenu2());
		}
		return jJMenuBar;
	}
	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenu() {
		if (jMenu == null) {
			jMenu = new JMenu();
			jMenu.setText("Connect");
			jMenu.setBackground(new java.awt.Color(204,204,204));
			jMenu.add(getJMenuItem1());
		}
		return jMenu;
	}
	/**
	 * This method initializes jMenu1	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenu1() {
		if (jMenu1 == null) {
			jMenu1 = new JMenu();
			jMenu1.setText("Window");
			jMenu1.setBackground(new java.awt.Color(204,204,204));
		}
		return jMenu1;
	}
	/**
	 * This method initializes jMenu2	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenu2() {
		if (jMenu2 == null) {
			jMenu2 = new JMenu();
			jMenu2.setText("Help");
			jMenu2.setBackground(new java.awt.Color(204,204,204));
			jMenu2.add(getJMenuItem());
		}
		return jMenu2;
	}
	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem() {
		if (jMenuItem == null) {
			jMenuItem = new JMenuItem();
			jMenuItem.setText("About Hirommy Platform");
			jMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					HirommyInfoWindow.getInstance().setVisible(true);
				}
			});
		}
		return jMenuItem;
	}
	/**
	 * This method initializes jMenuItem1	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJMenuItem1() {
		if (jMenuItem1 == null) {
			jMenuItem1 = new JMenuItem();
			jMenuItem1.setActionCommand("exit");
			jMenuItem1.setText("exit");
			jMenuItem1.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// exit Hirommy.
					System.exit(0);
				}
			});
		}
		return jMenuItem1;
	}
         }
