/*
 * Created on 2004/08/31
 *
 */
package jnet.hirommy.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Toolkit;

import javax.swing.JFrame;

/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class MassageBox extends JFrame {
	
	public static final int WIDTH = 400;
	public static final int HEIGHT = 200;
	
	/**
	 * normal massage type.
	 */
	public static final int NORMAL = 0;
	
	/**
	 * caution massage type.
	 */
	public static final int CAUTION = 1;
	
	/**
	 * warning massage type.
	 */
	public static final int WARNING = 2;
	
	/**
	 * massage
	 */
	private String msg = null;
	
	/**
	 * massage type number.
	 */
	private int msgType = 0;
	
	
	/**
	 * This is a default constractor.
	 * 
	 * @param msg message of this massage box.
	 */
	public MassageBox(String msg, int msgType) {
		super("Massage Box");
		this.msg = msg;
		this.msgType = msgType;
		this.setResizable(false);
		this.setSize(WIDTH, HEIGHT);
		
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	 	this.setLocation( (int) (screenSize.getWidth()-WIDTH)/2, (int) (screenSize.getHeight()-HEIGHT)/2 );
	}
	
	/**
	 * paint.
	 */
	public void paint(Graphics g) {
		super.paint(g);
		
		// set x, y on the origin 
		Insets is = getInsets();
		int x = (getWidth() - is.left - is.right ) / 2 + is.left;
		int y = (getHeight() - is.top - is.bottom) / 2;
		
		// draw massage.
		g.setColor(Color.white);
		Font fnt = new Font("scale", Font.BOLD, 15);
		g.setFont(fnt);
		FontMetrics fm = getFontMetrics(g.getFont());
		
		if (msgType == CAUTION) {
			g.setColor(Color.YELLOW);
		} else if (msgType == WARNING) {
			g.setColor(Color.RED);
		} else {
			g.setColor(Color.BLACK);
		}
		g.drawString("msg", x - fm.stringWidth(msg), y);
	}
}
