/*
 * Created on 2004/08/10
 *
 */
package jnet.hirommy.gui;

import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;

import javax.swing.ImageIcon;
import javax.swing.JInternalFrame;

import jnet.hirommy.info.HirommyPacket;
import jnet.hirommy.util.Theme;
import jnet.hirommy.util.ThemeImpl;
import jnet.its.gps.HeaddingCalculator;
import jnet.its.gps.SimpleHeaddingCalculationMethod;

/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class ReceivingInfoViewInternalFrame extends JInternalFrame implements Theme {

	public static final int HEIGHT = 220;
	public static final int WIDTH = 300;
	
	private static final int DELTA = 14;
	private static final int TOP_SPACE = 40;
	private static final int LEFT_SPACE = 10;
	private static final int TOP_INSET = 25;
	private static final int DIVIDE_VALE = 3;
	
	private HirommyPacket hirommyPacket = null;
	
	private Image img;
	private String backgroundImg;							// background imagge of GPS Viewer
	private boolean backgroundImgFlag = false;			// tureFuse image, falseFdon't use image
	private int theme = NONE;								// terma name.
	
	// HeaddingCalculator
	private HeaddingCalculator headdingCalculator =
			new SimpleHeaddingCalculationMethod(); 
	
	/**
	 * This is the default constructor
	 */
	public ReceivingInfoViewInternalFrame() {
		super("Receiving Infomation Viewer");
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(WIDTH,HEIGHT);
	}
	/**
	 * paint.
	 */
	public void paint(Graphics g) {
		super.paint(g);
		
		// set x : center of this frame. 
		Insets is = getInsets();
		int x = (getWidth() - is.left - is.right ) / 2 + is.left;
		int num = 0;
		
		// draw background image.
		if(backgroundImgFlag){
			img = new ImageIcon(backgroundImg).getImage();
			g.drawImage(img, is.left,
						(int)TOP_INSET, getWidth() - is.left * 2,
						getHeight() - is.top - is.bottom,
						this);	// display background image
		}
		
		// display receiving infomation.
		String str = null;
		g.setColor(ThemeImpl.getThemeStringColor(theme));	// change color for theme.
		Font fnt = new Font("scale", Font.PLAIN, 13);		// set font.
		g.setFont(fnt);
		
		// display string
		// user name
		g.drawString("UserName", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// terminal type
		g.drawString("Terminal", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// authorization
		g.drawString("Authorization", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// IP address
		g.drawString("IPaddress", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// time
		g.drawString("Time", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// latitude
		g.drawString("Latitude", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// longitude
		g.drawString("Longitude", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// state
		g.drawString("state", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// satellite
		g.drawString("satellite", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// altitude
		g.drawString("altitude", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// accel
		g.drawString("Accel", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// speed
		g.drawString("Speed", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
		
		// headding
		g.drawString("Headding", LEFT_SPACE, TOP_SPACE + DELTA * num);
		num++;
			
		try {	
			// display value.
			num = 0;
			g.drawString(": " + hirommyPacket.getMyProfile().getUserName(), getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// terminal type
			if (hirommyPacket.getMyProfile().getTerminalType() == 0) {
				str = "Vehicle";
			} else if (hirommyPacket.getMyProfile().getTerminalType() == 1) {
				str = "Pedestrian";
			} else {
				str = "Other";
			}
			g.drawString(": " + str, getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// authorization
			if (hirommyPacket.getMyProfile().getAuthorizeType() == 0) {
				str = "GOVERMENT";
			} else {
				str = "NONE";
			}
			g.drawString(": " + str, getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// IPAddress
			g.drawString(": " + hirommyPacket.getIpAddr() , getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// Hostname
			g.drawString(": " + hirommyPacket.getGpsInfo().getTime(), getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// latitude
			g.drawString(": " + hirommyPacket.getGpsInfo().getLatitude(), getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// longitude
			g.drawString(": " + hirommyPacket.getGpsInfo().getLongitude(), getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// state
			g.drawString(": " + hirommyPacket.getGpsInfo().getState(), getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// satellite
			g.drawString(": " + hirommyPacket.getGpsInfo().getSatellite(), getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// altitude
			g.drawString(": " + hirommyPacket.getGpsInfo().getAltitude() + " m", getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// accel
			g.drawString(": " + hirommyPacket.getOptionInfo().getAccel() + " m/s", getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// speed
			g.drawString(": " + hirommyPacket.getOptionInfo().getSpeed() + " km/h", getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			num++;
			
			// headding
			String headding = headdingCalculator.getHeddingName(hirommyPacket.getOptionInfo().getHeadding());
			g.drawString(": " + headding, getWidth() / DIVIDE_VALE + LEFT_SPACE, TOP_SPACE + DELTA * num);
			
		} catch (NullPointerException e) {
			System.out.println("Error : NullPointerException.");
			e.printStackTrace();
		}
	}
	/**
	 * @param hirommyPacket The hirommyPacket to set.
	 */
	public void setHirommyPacket(HirommyPacket hirommyPacket) {
		this.hirommyPacket = hirommyPacket;
	}
	/**
	 * set background of ReceivingInfoViewInternalFrame
	 * @param id a number of background image
	 */
	public void setBackgroundImg(int id) {
		this.theme = id;
		if(id == NONE) {
			this.backgroundImg = null;
			this.backgroundImgFlag = false;
		} else {
			this.backgroundImg = "img/" + ThemeImpl.getThemeName(id) + "/riback.jpg";
			this.backgroundImgFlag = true;
		}
	}
}
