/*
 * Created on 2004/08/16
 *
 */
package jnet.hirommy.gui;

import javax.swing.JInternalFrame;

import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.JButton;

import jnet.hirommy.core.SystemProperty;
import jnet.hirommy.info.MyProfile;
import jnet.hirommy.info.MyProfileImpl;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class SetUpPropertyInternalFrame extends JInternalFrame {
	
	public static final int WIDTH = 300;
	public static final int HEIGHT = 200;
	
	// item lists
	private String[] serialPortNumberLists = {"COM1", "COM2", "COM3", "COM4"};
	private String[] authorizationLists = {"Goverment", "User", "COCTerminal"};
	private String[] terminalTypeLists = {"Vehcle", "Pedestrian"};
	
	// setting date
	private String serialPortNumber = "COM1";
	private int authorization = MyProfile.COC_TERMINAL;
	private int terminalType = MyProfile.VEHICLE;
	
	private javax.swing.JPanel jContentPane = null;

	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JLabel jLabel4 = null;
	private JLabel jLabel5 = null;
	private JComboBox jComboBox2 = null;
	private JTextField jTextField = null;
	private JComboBox jComboBox3 = null;
	private JComboBox jComboBox4 = null;
	private JButton jButton = null;
	private JButton jButton1 = null;
	/**
	 * This is the default constructor
	 */
	public SetUpPropertyInternalFrame() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setTitle("SetUp Window");
		this.setSize(300,250);
		this.setContentPane(getJContentPane());
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jLabel5 = new JLabel();
			jLabel4 = new JLabel();
			jLabel3 = new JLabel();
			jLabel2 = new JLabel();
			java.awt.GridLayout gridLayout1 = new GridLayout();
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(gridLayout1);
			gridLayout1.setRows(5);
			jContentPane.add(jLabel2, null);
			jContentPane.add(getJComboBox2(), null);
			jContentPane.add(jLabel3, null);
			jContentPane.add(getJTextField(), null);
			jContentPane.add(jLabel4, null);
			jContentPane.add(getJComboBox3(), null);
			jContentPane.add(jLabel5, null);
			jContentPane.add(getJComboBox4(), null);
			gridLayout1.setColumns(2);
			jContentPane.add(getJButton(), null);
			jContentPane.add(getJButton1(), null);
			gridLayout1.setColumns(2);
			jLabel3.setText("User Name");
			jLabel4.setText("Authorization");
			jLabel5.setText("Terminal Type");
			gridLayout1.setColumns(2);
			jLabel2.setText("Serial Port");
		}
		return jContentPane;
	}
	/**
	 * This method initializes jComboBox2	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJComboBox2() {
		if (jComboBox2 == null) {
			jComboBox2 = new JComboBox();
			jComboBox2.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// setting serial port number.
					if (jComboBox2.getSelectedItem() == serialPortNumberLists[0]) {
						serialPortNumber = serialPortNumberLists[0];
					} else if ((jComboBox2.getSelectedItem() == serialPortNumberLists[1])) {
						serialPortNumber = serialPortNumberLists[1];
					} else if (jComboBox2.getSelectedItem() == serialPortNumberLists[2]) {
						serialPortNumber = serialPortNumberLists[2];
					} else if (jComboBox2.getSelectedItem() == serialPortNumberLists[3]) {
						serialPortNumber = serialPortNumberLists[3];
					}
				}
			});
		}
		for (int i = 0; i < serialPortNumberLists.length; i++) {
			jComboBox2.addItem(serialPortNumberLists[i]);
		}
		return jComboBox2;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
		}
		jTextField.setText(MyProfileImpl.getInstance().getUserName());
		return jTextField;
	}
	/**
	 * This method initializes jComboBox3	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJComboBox3() {
		if (jComboBox3 == null) {
			jComboBox3 = new JComboBox();
			jComboBox3.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// setting authorization.
					if (jComboBox3.getSelectedItem() == authorizationLists[0]) {
						authorization = MyProfile.GOVERMENT;
					} else if (jComboBox3.getSelectedItem() == authorizationLists[1]) {
						authorization = MyProfile.USER;
					} else if (jComboBox3.getSelectedItem() == authorizationLists[2]) {
						authorization = MyProfile.COC_TERMINAL;
					}
				}
			});
		}
		for (int i = 0; i < authorizationLists.length; i++) {
			jComboBox3.addItem(authorizationLists[i]);
		}
		return jComboBox3;
	}
	/**
	 * This method initializes jComboBox4	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJComboBox4() {
		if (jComboBox4 == null) {
			jComboBox4 = new JComboBox();
			jComboBox4.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// setting terminal type
					if (jComboBox4.getSelectedItem() == terminalTypeLists[0]) {
						terminalType = MyProfile.VEHICLE;
					} else if (jComboBox4.getSelectedItem() == terminalTypeLists[1]) {
						terminalType = MyProfile.PEDESTRIAN;
					}
				}
			});
		}
		for (int i = 0; i < terminalTypeLists.length; i++) {
			jComboBox4.addItem(terminalTypeLists[i]);
		}
		return jComboBox4;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("OK");
			jButton.setBackground(new java.awt.Color(255,255,153));
			jButton.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jButton.setForeground(new java.awt.Color(0,51,153));
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// setting SystemProperty and MyProfile
					SystemProperty.getInstance().setSerialPortNumber(serialPortNumber);
					MyProfileImpl.getInstance().setUserName(jTextField.getText());
					MyProfileImpl.getInstance().setAuthorizeType(authorization);
					MyProfileImpl.getInstance().setTerminalType(terminalType);
				}
			});
		}
		return jButton;
	}
	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Save");
			jButton1.setBackground(new java.awt.Color(255,255,153));
			jButton1.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jButton1.setForeground(new java.awt.Color(0,51,153));
		}
		return jButton1;
	}
  }
