/*
 * Created on 2004/08/10
 *
 */
package jnet.hirommy.gui;

import javax.swing.JPanel;

import javax.swing.JDesktopPane;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class SetUpTabPanel extends JPanel {
	
	private static final int LEFT_INSET = 8;
	
	private JDesktopPane jDesktopPane = null;
	private SetUpPropertyInternalFrame setUpPropertyInternalFrame = null;
	private SetUpIVCINternalFrame setUpIVCINternalFrame = null;
	private SetUpVPECInternalFrame setUpVPECInternalFrame = null;
	/**
	 * This is the default constructor
	 */
	public SetUpTabPanel() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		this.setSize(MainWindow.WIDTH, MainWindow.HEIGHT);
		this.add(getJDesktopPane(), null);
	}
	/**
	 * This method initializes jDesktopPane	
	 * 	
	 * @return javax.swing.JDesktopPane	
	 */    
	private JDesktopPane getJDesktopPane() {
		if (jDesktopPane == null) {
			jDesktopPane = new JDesktopPane();
			jDesktopPane.setPreferredSize(new java.awt.Dimension(MainWindow.WIDTH,MainWindow.HEIGHT));
			jDesktopPane.setBackground(new java.awt.Color(102,102,102));
			jDesktopPane.add(getSetUpPropertyInternalFrame(), null);
			jDesktopPane.add(getSetUpIVCINternalFrame(), null);
			jDesktopPane.add(getSetUpVPECInternalFrame(), null);
		}
		return jDesktopPane;
	}
	/**
	 * This method initializes setUpPropertyInternalFrame	
	 * 	
	 * @return jnet.hirommy.gui.SetUpPropertyInternalFrame	
	 */    
	private SetUpPropertyInternalFrame getSetUpPropertyInternalFrame() {
		if (setUpPropertyInternalFrame == null) {
			setUpPropertyInternalFrame = new SetUpPropertyInternalFrame();
			setUpPropertyInternalFrame.setBounds(LEFT_INSET, 0, SetUpPropertyInternalFrame.WIDTH, SetUpPropertyInternalFrame.HEIGHT);
		}
		setUpPropertyInternalFrame.setVisible(true);
		return setUpPropertyInternalFrame;
	}
	/**
	 * This method initializes setUpIVCINternalFrame	
	 * 	
	 * @return jnet.hirommy.gui.SetUpIVCINternalFrame	
	 */    
	private SetUpIVCINternalFrame getSetUpIVCINternalFrame() {
		if (setUpIVCINternalFrame == null) {
			setUpIVCINternalFrame = new SetUpIVCINternalFrame();
			setUpIVCINternalFrame.setBounds(LEFT_INSET + SetUpPropertyInternalFrame.WIDTH, 0, SetUpIVCINternalFrame.WIDTH, SetUpIVCINternalFrame.HEIGHT);
		}
		setUpIVCINternalFrame.setVisible(true);
		return setUpIVCINternalFrame;
	}
	/**
	 * This method initializes setUpVPECInternalFrame	
	 * 	
	 * @return jnet.hirommy.gui.SetUpVPECInternalFrame	
	 */    
	private SetUpVPECInternalFrame getSetUpVPECInternalFrame() {
		if (setUpVPECInternalFrame == null) {
			setUpVPECInternalFrame = new SetUpVPECInternalFrame();
			setUpVPECInternalFrame.setBounds(LEFT_INSET + SetUpPropertyInternalFrame.WIDTH, SetUpIVCINternalFrame.HEIGHT + LEFT_INSET / 5, SetUpVPECInternalFrame.WIDTH, SetUpVPECInternalFrame.HEIGHT);
		}
		setUpVPECInternalFrame.setVisible(true);
		return setUpVPECInternalFrame;
	}
    }  //  @jve:decl-index=0:visual-constraint="10,10"
