/*
 * Created on 2004/09/01
 *
 */
package jnet.hirommy.gui;

import javax.swing.JInternalFrame;

import java.awt.GridLayout;
import javax.swing.JButton;

import jnet.hirommy.sim.VirtualNetwork;
import jnet.hirommy.util.file.DataSourceReader;

import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JComboBox;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class SimulationSetUpInternalFrame extends JInternalFrame {
	
	public static final int WIDTH = 300;
	public static final int HEIGHT = 300;
	
	// true:simple mode, false:detail mode.
	private boolean simpleMode = true;
	
	private String[] simSpeedLists = {"Real Time",
									   "1/2 speed ",
									   "2/3 x speed",
									   "2 x speed",
									   "10 x speed"
									   };
	
	private javax.swing.JPanel jContentPane = null;

	private JButton jButton = null;
	private JButton jButton1 = null;
	private JTextField jTextField = null;
	private JButton jButton2 = null;
	private JCheckBox jCheckBox = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JTextField jTextField1 = null;
	private JTextField jTextField2 = null;
	private JPanel jPanel = null;
	private JPanel jPanel1 = null;
	private JPanel jPanel2 = null;
	private JLabel jLabel = null;
	private JPanel jPanel3 = null;
	private JPanel jPanel4 = null;
	private JPanel jPanel5 = null;
	private JCheckBox jCheckBox1 = null;
	private JPanel jPanel6 = null;
	private JLabel jLabel3 = null;
	private JPanel jPanel7 = null;
	private JLabel jLabel4 = null;
	private JPanel jPanel8 = null;
	private JPanel jPanel9 = null;
	private JPanel jPanel10 = null;
	private JLabel jLabel5 = null;
	private JButton jButton3 = null;
	private JComboBox jComboBox = null;
	/**
	 * This is the default constructor
	 */
	public SimulationSetUpInternalFrame() {
		super("Simulation SetUp Window");
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(WIDTH,HEIGHT);
		this.setContentPane(getJContentPane());
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jLabel2 = new JLabel();
			jLabel1 = new JLabel();
			java.awt.GridLayout gridLayout1 = new GridLayout();
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(gridLayout1);
			gridLayout1.setRows(11);
			jLabel1.setText("My Infomation");
			jLabel1.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jLabel2.setText("Target Infomation");
			jLabel2.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getJPanel10(), null);
			jContentPane.add(getJPanel8(), null);
			jContentPane.add(getJPanel9(), null);
			jContentPane.add(getJPanel7(), null);
			jContentPane.add(getJPanel2(), null);
			jContentPane.add(getJPanel1(), null);
			jContentPane.add(getJPanel6(), null);
			jContentPane.add(getJPanel5(), null);
			jContentPane.add(getJPanel3(), null);
			jContentPane.add(getJPanel4(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Start");
			jButton.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jButton.setBackground(new java.awt.Color(255,255,153));
			jButton.setForeground(new java.awt.Color(0,51,153));
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// start simulation.
					new Thread(new VirtualNetwork()).start();
					
					// unenabled start button.
					jButton.setEnabled(false);
					
					// enabled stop button.
					jButton1.setEnabled(true);
					
					// unenabled road button.
					jButton2.setEnabled(false);
				}
			});
		}
		return jButton;
	}
	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Stop");
			jButton1.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// ended simulation.
					VirtualNetwork.close();
					
					// unenabled stop button
					jButton1.setEnabled(false);
					
					// enabled start button
					jButton.setEnabled(true);
					
					// enabled road button
					jButton2.setEnabled(true);
				}
			});
		}
		jButton1.setEnabled(false);
		jButton1.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
		jButton1.setBackground(new java.awt.Color(255,255,153));
		jButton1.setForeground(new java.awt.Color(204,0,0));
		return jButton1;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setText("filled in file name.");
			jTextField.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 14));
		}
		return jTextField;
	}
	/**
	 * This method initializes jButton2	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText("Road");
			jButton2.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jButton2.setBackground(new java.awt.Color(255,255,153));
			jButton2.setForeground(new java.awt.Color(0,51,153));
			jButton2.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (simpleMode) {	// if simple mode.
						// road real data.
						DataSourceReader reader = new DataSourceReader();
						reader.read(jTextField.getText());
					} else {
						// TODO cording detail mode.
						// road XML file.
						DataSourceReader reader = new DataSourceReader();
						reader.read(jTextField1.getText(), jTextField2.getText());
					}
				}
			});
		}
		return jButton2;
	}
	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("Detail Mode");
			jCheckBox.addItemListener(new java.awt.event.ItemListener() { 
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (e.getItemSelectable() == jCheckBox) {
						if (jCheckBox.isSelected()) {
							simpleMode = false;	// detail mode.
						} else {
							simpleMode = true;		// simple mode.
						}
					}
				}
			});
			
		}
		jCheckBox.setSelected(true);
		return jCheckBox;
	}
	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setText("my info ifle");
		}
		return jTextField1;
	}
	/**
	 * This method initializes jTextField2	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setText("targetinfofile");
		}
		return jTextField2;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel() {
		if (jPanel == null) {
			java.awt.GridLayout gridLayout8 = new GridLayout();
			jPanel = new JPanel();
			jPanel.setLayout(gridLayout8);
			gridLayout8.setRows(1);
			jPanel.add(getJButton(), null);
			jPanel.add(getJButton1(), null);
			jPanel.add(getJButton2(), null);
		}
		return jPanel;
	}
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			java.awt.GridLayout gridLayout9 = new GridLayout();
			jPanel1 = new JPanel();
			jPanel1.setLayout(gridLayout9);
			gridLayout9.setRows(1);
		}
		return jPanel1;
	}
	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jLabel = new JLabel();
			java.awt.GridLayout gridLayout10 = new GridLayout();
			jPanel2 = new JPanel();
			jPanel2.setLayout(gridLayout10);
			jLabel.setText("File Name ");
			jLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			gridLayout10.setRows(1);
			jPanel2.add(jLabel, null);
			jPanel2.add(getJTextField(), null);
		}
		return jPanel2;
	}
	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			java.awt.GridLayout gridLayout11 = new GridLayout();
			jPanel3 = new JPanel();
			jPanel3.setLayout(gridLayout11);
			gridLayout11.setRows(1);
			jPanel3.add(jLabel1, null);
			jPanel3.add(getJTextField1(), null);
		}
		return jPanel3;
	}
	/**
	 * This method initializes jPanel4	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			java.awt.GridLayout gridLayout12 = new GridLayout();
			jPanel4 = new JPanel();
			jPanel4.setLayout(gridLayout12);
			gridLayout12.setRows(1);
			jPanel4.add(jLabel2, null);
			jPanel4.add(getJTextField2(), null);
		}
		return jPanel4;
	}
	/**
	 * This method initializes jPanel5	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel5() {
		if (jPanel5 == null) {
			java.awt.GridLayout gridLayout13 = new GridLayout();
			jPanel5 = new JPanel();
			jPanel5.setLayout(gridLayout13);
			gridLayout13.setRows(1);
			jPanel5.add(getJCheckBox(), null);
			jPanel5.add(getJCheckBox1(), null);
		}
		return jPanel5;
	}
	/**
	 * This method initializes jCheckBox1	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox1() {
		if (jCheckBox1 == null) {
			jCheckBox1 = new JCheckBox();
			jCheckBox1.setText("Synchronization");
			jCheckBox1.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
		}
		jCheckBox1.setSelected(true);
		return jCheckBox1;
	}
	/**
	 * This method initializes jPanel6	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel6() {
		if (jPanel6 == null) {
			jLabel3 = new JLabel();
			jPanel6 = new JPanel();
			jLabel3.setText("----- Detail Mode Setting -----");
			jLabel3.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jPanel6.setBackground(new java.awt.Color(204,204,204));
			jPanel6.add(jLabel3, null);
		}
		return jPanel6;
	}
	/**
	 * This method initializes jPanel7	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel7() {
		if (jPanel7 == null) {
			jLabel4 = new JLabel();
			jPanel7 = new JPanel();
			jLabel4.setText("----- Simple Mode Setting -----");
			jLabel4.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jPanel7.setBackground(new java.awt.Color(204,204,204));
			jPanel7.add(jLabel4, null);
		}
		return jPanel7;
	}
	/**
	 * This method initializes jPanel8	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel8() {
		if (jPanel8 == null) {
			java.awt.GridLayout gridLayout15 = new GridLayout();
			jPanel8 = new JPanel();
			jPanel8.setLayout(gridLayout15);
			gridLayout15.setRows(1);
			jPanel8.add(getJButton3(), null);
			jPanel8.add(getJComboBox(), null);
		}
		return jPanel8;
	}
	/**
	 * This method initializes jPanel9	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel9() {
		if (jPanel9 == null) {
			jPanel9 = new JPanel();
		}
		return jPanel9;
	}
	/**
	 * This method initializes jPanel10	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel10() {
		if (jPanel10 == null) {
			jLabel5 = new JLabel();
			jPanel10 = new JPanel();
			jLabel5.setText("----- Simulation Parameter -----");
			jLabel5.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jPanel10.add(jLabel5, null);
		}
		return jPanel10;
	}
	/**
	 * This method initializes jButton3	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setText("Speed");
			jButton3.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
		}
		return jButton3;
	}
	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJComboBox() {
		if (jComboBox == null) {
			jComboBox = new JComboBox();
			jComboBox.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jComboBox.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// change simualtion speed.
					if (jComboBox.getSelectedItem() == simSpeedLists[0]) {
						VirtualNetwork.setSimSpeed(1000);
					} else if (jComboBox.getSelectedItem() == simSpeedLists[1]) {
						VirtualNetwork.setSimSpeed(2000);
					} else if (jComboBox.getSelectedItem() == simSpeedLists[2]) {
						VirtualNetwork.setSimSpeed(1500);
					} else if (jComboBox.getSelectedItem() == simSpeedLists[3]) {
						VirtualNetwork.setSimSpeed(500);
					} else if (jComboBox.getSelectedItem() == simSpeedLists[4]) {
						VirtualNetwork.setSimSpeed(100);
					}
				}
			});
		}
		for (int i = 0; i < simSpeedLists.length; i++) {
			jComboBox.addItem(simSpeedLists[i]);
		}
		return jComboBox;
	}
                      }
