/*
 * Created on 2004/09/01
 *
 */
package jnet.hirommy.gui;

import javax.swing.JInternalFrame;

import java.awt.GridLayout;
import jnet.hirommy.util.SimulatinViewerHandlerImpl;
import jnet.hirommy.util.ViewerHandler;

import javax.swing.JPanel;
import javax.swing.JButton;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class SimulationViewerSetUpInternalFrame extends JInternalFrame {
	
	public static final int WIDTH = 300;
	public static final int HEIGHT = 210;
	
	private javax.swing.JPanel jContentPane = null;

	private ViewerControlComponentsViewerTheme viewerControlComponentsViewerTheme = null;
	private JPanel jPanel = null;
	private JButton jButton = null;
	private ViewerControlComponentsChexBoxPanel1 viewerControlComponentsChexBoxPanel1 = null;
	private ViewerControlComponentsViewerRange viewerControlComponentsViewerRange = null;
	private ViewerControlComponentsTargetSize viewerControlComponentsTargetSize = null;
	private ViewerControlComponentsChexBoxPanel2 viewerControlComponentsChexBoxPanel2 = null;
	private ViewerControlComponentsChexBoxPanel3 viewerControlComponentsChexBoxPanel3 = null;
	/**
	 * This is the default constructor
	 */
	public SimulationViewerSetUpInternalFrame() {
		super("Viewer SetUp Window");
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(WIDTH,HEIGHT);
		this.setContentPane(getJContentPane());
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			java.awt.GridLayout gridLayout5 = new GridLayout();
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(gridLayout5);
			gridLayout5.setRows(7);
			gridLayout5.setHgap(0);
			gridLayout5.setVgap(4);
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getViewerControlComponentsViewerTheme(), null);
			jContentPane.add(getViewerControlComponentsViewerRange(), null);
			jContentPane.add(getViewerControlComponentsTargetSize(), null);
			jContentPane.add(getViewerControlComponentsChexBoxPanel1(), null);
			jContentPane.add(getViewerControlComponentsChexBoxPanel2(), null);
			jContentPane.add(getViewerControlComponentsChexBoxPanel3(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes viewerControlComponentsViewerTheme	
	 * 	
	 * @return jnet.hirommy.gui.ViewerControlComponentsViewerTheme	
	 */    
	private ViewerControlComponentsViewerTheme getViewerControlComponentsViewerTheme() {
		if (viewerControlComponentsViewerTheme == null) {
			viewerControlComponentsViewerTheme = new ViewerControlComponentsViewerTheme();
		}
		return viewerControlComponentsViewerTheme;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel() {
		if (jPanel == null) {
			java.awt.GridLayout gridLayout6 = new GridLayout();
			jPanel = new JPanel();
			jPanel.setLayout(gridLayout6);
			gridLayout6.setRows(1);
			jPanel.add(getJButton(), null);
		}
		return jPanel;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Update");
			jButton.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jButton.setBackground(new java.awt.Color(255,255,153));
			jButton.setForeground(new java.awt.Color(0,51,153));
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					ViewerHandler viewerHandler = new SimulatinViewerHandlerImpl();
					// update GpsViewer.
					viewerHandler.repaintGpsViewer();
				}
			});
		}
		return jButton;
	}
	/**
	 * This method initializes viewerControlComponentsChexBoxPanel1	
	 * 	
	 * @return jnet.hirommy.gui.ViewerControlComponentsChexBoxPanel1	
	 */    
	private ViewerControlComponentsChexBoxPanel1 getViewerControlComponentsChexBoxPanel1() {
		if (viewerControlComponentsChexBoxPanel1 == null) {
			viewerControlComponentsChexBoxPanel1 = new ViewerControlComponentsChexBoxPanel1();
		}
		return viewerControlComponentsChexBoxPanel1;
	}
	/**
	 * This method initializes viewerControlComponentsViewerRange	
	 * 	
	 * @return jnet.hirommy.gui.ViewerControlComponentsViewerRange	
	 */    
	private ViewerControlComponentsViewerRange getViewerControlComponentsViewerRange() {
		if (viewerControlComponentsViewerRange == null) {
			viewerControlComponentsViewerRange = new ViewerControlComponentsViewerRange();
		}
		return viewerControlComponentsViewerRange;
	}
	/**
	 * This method initializes viewerControlComponentsTargetSize	
	 * 	
	 * @return jnet.hirommy.gui.ViewerControlComponentsTargetSize	
	 */    
	private ViewerControlComponentsTargetSize getViewerControlComponentsTargetSize() {
		if (viewerControlComponentsTargetSize == null) {
			viewerControlComponentsTargetSize = new ViewerControlComponentsTargetSize();
		}
		return viewerControlComponentsTargetSize;
	}
	/**
	 * This method initializes viewerControlComponentsChexBoxPanel2	
	 * 	
	 * @return jnet.hirommy.gui.ViewerControlComponentsChexBoxPanel2	
	 */    
	private ViewerControlComponentsChexBoxPanel2 getViewerControlComponentsChexBoxPanel2() {
		if (viewerControlComponentsChexBoxPanel2 == null) {
			viewerControlComponentsChexBoxPanel2 = new ViewerControlComponentsChexBoxPanel2();
		}
		return viewerControlComponentsChexBoxPanel2;
	}
	/**
	 * This method initializes viewerControlComponentsChexBoxPanel3	
	 * 	
	 * @return jnet.hirommy.gui.ViewerControlComponentsChexBoxPanel3	
	 */    
	private ViewerControlComponentsChexBoxPanel3 getViewerControlComponentsChexBoxPanel3() {
		if (viewerControlComponentsChexBoxPanel3 == null) {
			viewerControlComponentsChexBoxPanel3 = new ViewerControlComponentsChexBoxPanel3();
		}
		return viewerControlComponentsChexBoxPanel3;
	}
    }
