/*
 * Created on 2004/08/16
 *
 */
package jnet.hirommy.gui;

import javax.swing.JPanel;

import javax.swing.JDesktopPane;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class UtilityPanel extends JPanel {
	
	private static final int GAP = 15;
	private static final int LEFT_INSET = 8;
	
	private JDesktopPane jDesktopPane = null;
	private AudioControlInternalFrame audioControlInternalFrame = null;
	/**
	 * This is the default constructor
	 */
	public UtilityPanel() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		this.setSize(MainWindow.WIDTH, MainWindow.HEIGHT);
		this.add(getJDesktopPane(), null);
	}
	/**
	 * This method initializes jDesktopPane	
	 * 	
	 * @return javax.swing.JDesktopPane	
	 */    
	private JDesktopPane getJDesktopPane() {
		if (jDesktopPane == null) {
			jDesktopPane = new JDesktopPane();
			jDesktopPane.setPreferredSize(new java.awt.Dimension(MainWindow.WIDTH,MainWindow.HEIGHT));
			jDesktopPane.setBackground(new java.awt.Color(102,102,102));
			jDesktopPane.add(getAudioControlInternalFrame(), null);
		}
		return jDesktopPane;
	}
	/**
	 * This method initializes audioControlInternalFrame	
	 * 	
	 * @return jnet.hirommy.gui.AudioControlInternalFrame	
	 */    
	private AudioControlInternalFrame getAudioControlInternalFrame() {
		if (audioControlInternalFrame == null) {
			audioControlInternalFrame = new AudioControlInternalFrame();
			audioControlInternalFrame.setBounds(LEFT_INSET, 0, 248, 100);
		}
		audioControlInternalFrame.setVisible(true);
		return audioControlInternalFrame;
	}
  }
