/*
 * Created on 2004/09/01
 *
 */
package jnet.hirommy.gui;

import javax.swing.JPanel;

import java.awt.GridLayout;
import javax.swing.JCheckBox;

import jnet.hirommy.util.SimulatinViewerHandlerImpl;
import jnet.hirommy.util.ViewerHandler;
import jnet.hirommy.util.ViewerHandlerImpl;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class ViewerControlComponentsChexBoxPanel2 extends JPanel {
	
	private static boolean simMode = false;
	
	private JCheckBox jCheckBox = null;
	private JCheckBox jCheckBox1 = null;
	/**
	 * This is the default constructor
	 */
	public ViewerControlComponentsChexBoxPanel2() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		java.awt.GridLayout gridLayout2 = new GridLayout();
		this.setLayout(gridLayout2);
		this.setSize(300,200);
		gridLayout2.setRows(1);
		this.add(getJCheckBox(), null);
		this.add(getJCheckBox1(), null);
	}
	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("Prediction");
			jCheckBox.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
		}
		jCheckBox.setSelected(true);
		jCheckBox.addItemListener(new java.awt.event.ItemListener() { 
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				if (e.getItemSelectable() == jCheckBox) {
					ViewerHandler vh;
					if (simMode) {
						vh = new SimulatinViewerHandlerImpl();
					} else {
						vh = new ViewerHandlerImpl();
					}
					if (jCheckBox.isSelected()) {
						// display direction.
						vh.getGpsViewerInstance().setPredictionFlag(true);
					} else {
						// don't display direction
						vh.getGpsViewerInstance().setPredictionFlag(false);
					}
				}
			}
		});
		return jCheckBox;
	}
	/**
	 * Thid method is setting simulation mode or not.
	 * 
	 * @param flag simlation mode on or not.
	 */
	public static void setSimlationMode(boolean flag) {
		simMode = flag;
	}
	/**
	 * This method initializes jCheckBox1	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox1() {
		if (jCheckBox1 == null) {
			jCheckBox1 = new JCheckBox();
			jCheckBox1.setText("Direction");
			jCheckBox1.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jCheckBox1.addItemListener(new java.awt.event.ItemListener() { 
				public void itemStateChanged(java.awt.event.ItemEvent e) {    
					if (e.getItemSelectable() == jCheckBox1) {
						ViewerHandler vh;
						if (simMode) {
							vh = new SimulatinViewerHandlerImpl();
						} else {
							vh = new ViewerHandlerImpl();
						}
						if (simMode) {
							vh = new SimulatinViewerHandlerImpl();
						} else {
							vh = new ViewerHandlerImpl();
						}
						if (jCheckBox1.isSelected()) {
							// display direction.
							vh.getGpsViewerInstance().setDirectionFlag(true);
						} else {
							// don't display direction
							vh.getGpsViewerInstance().setDirectionFlag(false);
						}
					}
				}
			});
		}
		jCheckBox1.setSelected(true);
		return jCheckBox1;
	}
  }
