/*
 * Created on 2004/09/07
 *
 */
package jnet.hirommy.gui;

import javax.swing.JPanel;

import java.awt.GridLayout;
import javax.swing.JCheckBox;

import jnet.hirommy.util.SimulatinViewerHandlerImpl;
import jnet.hirommy.util.ViewerHandler;
import jnet.hirommy.util.ViewerHandlerImpl;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class ViewerControlComponentsChexBoxPanel3 extends JPanel {
	
	private static boolean simMode = false;
	
	private JCheckBox jCheckBox = null;
	/**
	 * This is the default constructor
	 */
	public ViewerControlComponentsChexBoxPanel3() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		java.awt.GridLayout gridLayout11 = new GridLayout();
		this.setLayout(gridLayout11);
		this.setSize(300,200);
		gridLayout11.setRows(1);
		this.add(getJCheckBox(), null);
	}
	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("Reaction");
			jCheckBox.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jCheckBox.addItemListener(new java.awt.event.ItemListener() { 
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (e.getItemSelectable() == jCheckBox) {
						ViewerHandler vh;
						if (simMode) {
							vh = new SimulatinViewerHandlerImpl();
						} else {
							vh = new ViewerHandlerImpl();
						}
						if (jCheckBox.isSelected()) {
							// description on
							vh.getGpsViewerInstance().setReactRadius(true);
						} else {
							// description off
							vh.getGpsViewerInstance().setReactRadius(false);
						}
					}
				}
			});
		}
		return jCheckBox;
	}
	
	/**
	 * This is for setting simulation mode.
	 * 
	 * @param flag simulatin mode is on or not.
	 */
	public static void setSimulatinMode(boolean flag) {
		simMode = flag;
	}
 }
