/*
 * Created on 2004/09/01
 *
 */
package jnet.hirommy.gui;

import javax.swing.JPanel;

import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JComboBox;

import jnet.hirommy.util.SimulatinViewerHandlerImpl;
import jnet.hirommy.util.ViewerHandler;
import jnet.hirommy.util.ViewerHandlerImpl;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class ViewerControlComponentsTargetSize extends JPanel {
	
	private static boolean simMode = false;
	
	private String[] targetSizeLists = {"default",
										 "normal",
										 "big",
										 "very big"
										};
	private JLabel jLabel = null;
	private JComboBox jComboBox = null;
	/**
	 * This is the default constructor
	 */
	public ViewerControlComponentsTargetSize() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		jLabel = new JLabel();
		java.awt.GridLayout gridLayout2 = new GridLayout();
		this.setLayout(gridLayout2);
		this.setSize(300,200);
		gridLayout2.setRows(1);
		jLabel.setText("Target Size");
		jLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
		this.add(jLabel, null);
		this.add(getJComboBox(), null);
	}
	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJComboBox() {
		if (jComboBox == null) {
			jComboBox = new JComboBox();
			jComboBox.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jComboBox.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					ViewerHandler vh;
					if (simMode) {
						vh = new SimulatinViewerHandlerImpl();
					} else {
						vh = new ViewerHandlerImpl();
					}
					if (jComboBox.getSelectedItem() == targetSizeLists[0]) {
						vh.getGpsViewerInstance().setTargetSize(8);
					} else if (jComboBox.getSelectedItem() == targetSizeLists[1]) {
						vh.getGpsViewerInstance().setTargetSize(10);
					} else if (jComboBox.getSelectedItem() == targetSizeLists[2]) {
						vh.getGpsViewerInstance().setTargetSize(15);
					} else if (jComboBox.getSelectedItem() == targetSizeLists[3]) {
						vh.getGpsViewerInstance().setTargetSize(20);
					}
				}
			});
		}
		for (int i = 0; i < targetSizeLists.length; i++) {
			jComboBox.addItem(targetSizeLists[i]);
		}
		return jComboBox;
	}
	/**
	 * Thid method is setting simulation mode or not.
	 * 
	 * @param flag simlation mode on or not.
	 */
	public static void setSimlationMode(boolean flag) {
		simMode = flag;
	}
 }
