/*
 * Created on 2004/09/01
 *
 */
package jnet.hirommy.gui;

import javax.swing.JPanel;

import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JComboBox;

import jnet.hirommy.util.SimulatinViewerHandlerImpl;
import jnet.hirommy.util.Theme;
import jnet.hirommy.util.ViewerHandler;
import jnet.hirommy.util.ViewerHandlerImpl;
/**
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class ViewerControlComponentsViewerTheme extends JPanel {
	
	private static boolean simMode = false;
	
	private String[] backgroundLists = {"none",
										 "Hiromi Kitty",
										 "Helloween"
										};

	private JLabel jLabel = null;
	private JComboBox jComboBox = null;
	/**
	 * This is the default constructor
	 */
	public ViewerControlComponentsViewerTheme() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		jLabel = new JLabel();
		java.awt.GridLayout gridLayout1 = new GridLayout();
		this.setLayout(gridLayout1);
		this.setSize(300,200);
		gridLayout1.setRows(1);
		jLabel.setText("Viewer Theme");
		jLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
		this.add(jLabel, null);
		this.add(getJComboBox(), null);
	}
	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getJComboBox() {
		if (jComboBox == null) {
			jComboBox = new JComboBox();
			jComboBox.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jComboBox.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					ViewerHandler vh;
					if (simMode) {
						vh = new SimulatinViewerHandlerImpl();
					} else {
						vh = new ViewerHandlerImpl();
					}
					try {
						// setting background of GpsViewer.
						if (jComboBox.getSelectedItem() == backgroundLists[0]) {
							// none
							vh.getGpsViewerInstance().setBackgroundImg(Theme.NONE);
							vh.getMyPropertyViewerInstance().setBackgroundImg(Theme.NONE);
							vh.getReceivingInfoViewerInstance().setBackgroundImg(Theme.NONE);
						} else if (jComboBox.getSelectedItem() == backgroundLists[1]) {
							// Kitty
							vh.getGpsViewerInstance().setBackgroundImg(Theme.KITTY);
							vh.getMyPropertyViewerInstance().setBackgroundImg(Theme.KITTY);
							vh.getReceivingInfoViewerInstance().setBackgroundImg(Theme.KITTY);
						} else if (jComboBox.getSelectedItem() == backgroundLists[2]) {
							// Helloween
							vh.getGpsViewerInstance().setBackgroundImg(Theme.HELLOWEEN);
							vh.getMyPropertyViewerInstance().setBackgroundImg(Theme.HELLOWEEN);
							vh.getReceivingInfoViewerInstance().setBackgroundImg(Theme.HELLOWEEN);
						}
					} catch (NullPointerException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			});
		}
		for (int i = 0; i < backgroundLists.length; i++) {
			jComboBox.addItem(backgroundLists[i]);
		}
		return jComboBox;
	}
	/**
	 * Thid method is setting simulation mode or not.
	 * 
	 * @param flag simlation mode on or not.
	 */
	public static void setSimlationMode(boolean flag) {
		simMode = flag;
	}
 }
