/*
 * Created on 2004/08/20
 *
 */
package jnet.hirommy.info;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 * This is factory class for Building. 
 * This class reads information in the file to 
 * which the information on a building was written, 
 * and generates a Building object.
 * <br><br>
 * a File format that a building infomation was written is as follow.
 * <br>
 * building name, latitude, longitude \n <br>
 * <br>
 * for example, <br>
 * kansai-u, 3455.1111, 13554.3356<br>
 * In this example, kansai-u is a name of building
 * - 3455.1111 is latitude, 13554.3356 is longitude.
 * 
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class BuildingFactory {
	
	/**
	 * create building object from text file.
	 * 
	 * @return lists of building object.
	 */
	ArrayList createBuilding() {
		
		String buff = null;
		String name = null;							// name of building.
		String latitude = null;						// latitude of building.
		String longitude = null;					// longitude of buiding.
		ArrayList buildingLists = new ArrayList();	// list of building.
		
		try {
			BufferedReader reader =
					new BufferedReader(new FileReader("property/building.txt"));
			
			
			while ((buff = reader.readLine()) != null) {
				StringTokenizer st = new StringTokenizer(buff, ",");
				for(int i = 0; st.hasMoreTokens() == true; i++) {
					if(i == 0) {
						name = st.nextToken();		// get name.
					} else if(i == 1) {
						latitude = st.nextToken();	// get latitude.
					} else {
						longitude = st.nextToken();	// get longitude.
					}
				}
				buildingLists.add(new Building(name, latitude, longitude));
			}
			
		} catch (IOException e) {
			System.out.println("Error : IOException.");
			e.printStackTrace();
		}
		
		return buildingLists;
	}
}
