/*
 * Created on 2004/08/20
 *
 */
package jnet.hirommy.info;

import java.util.ArrayList;

/**
 * This is a class which saves a Building class
 * 
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class BuildingHandler {
	
	private static BuildingHandler buildingHandler = new BuildingHandler();
	
	private ArrayList buildingLists = new ArrayList();
	
	/**
	 * This is a default constractor.
	 *
	 */
	private BuildingHandler() {
		BuildingFactory factory = new BuildingFactory();
		buildingLists = factory.createBuilding();
	}
	/**
	 * 
	 * @return instance of this object.
	 */
	public static BuildingHandler getInstance() {
		return buildingHandler;
	}
	/**
	 * @return Returns the buildingLists.
	 */
	public ArrayList getBuildingLists() {
		return buildingLists;
	}
}
