/*
 * Created on 2004/08/09
 *
 */
package jnet.hirommy.info;

import java.io.Serializable;

/**
 * This class reprecents this terminal profile.
 * 
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class MyProfileImpl implements MyProfile, Serializable {
	
	private static MyProfileImpl myProfile = new MyProfileImpl();
	
	private MyProfileImpl() {
	}
	
	// TODO set up my profile.
	private String userName = "Kazuya Sakai";
	private int authorizeType = COC_TERMINAL;
	private int terminalType = PEDESTRIAN;
	
	/**
	 * string of this class.
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "<UserName>" + userName + "</UserName>"
				+ "<TerminalType>" + terminalType + "</TerminalType>"
				+ "<AuthorizeType>" + authorizeType + "</AuthorizeType>";
	}
	/**
	 * @return User Name.
	 * @see jnet.hirommy.info.MyProfile#getUserName()
	 */
	public String getUserName() {
		return userName;
	}
	/**
	 * @return Authorize Type.
	 * @see jnet.hirommy.info.MyProfile#getAuthorizeType()
	 */
	public int getAuthorizeType() {
		return authorizeType;
	}

	/**
	 * @return Terminal Type.
	 * @see jnet.hirommy.info.MyProfile#getTerminalType()
	 */
	public int getTerminalType() {
		return terminalType;
	}
	/**
	 * @param authorizeType The authorizeType to set.
	 */
	public void setAuthorizeType(int authorizeType) {
		this.authorizeType = authorizeType;
	}
	/**
	 * @param terminalType The terminalType to set.
	 */
	public void setTerminalType(int terminalType) {
		this.terminalType = terminalType;
	}
	/**
	 * @param userName The userName to set.
	 */
	public void setUserName(String userName) {
		this.userName = userName;
	}
	/**
	 * get MyProfileImple instance.
	 * 
	 * @return instance of MyProfileImpl.
	 */
	public static MyProfileImpl getInstance() {
		return myProfile;
	}
}
