/*
 * Created on 2004/09/01
 *
 */
package jnet.hirommy.sim;

import java.io.Serializable;
import java.util.LinkedList;
import java.util.NoSuchElementException;

import jnet.hirommy.info.HirommyPacket;

/**
 * This class expresses the sauce of real data.
 * 
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class RealDataSource implements Serializable {
	
	private static RealDataSource realDataSource = new RealDataSource();
	
	/**
	 * The history of the my infomation.
	 */
	private LinkedList myInfoLists = new LinkedList();
	
	/**
	 *  The history of the information received from other terminals
	 */
	private LinkedList targetInfoLists = new LinkedList();
	
	/**
	 * This is a default constractor.
	 *
	 */
	private RealDataSource() {
	}
	
	/**
	 * This method return hirommy packet.
	 * 
	 * @return my hirommy packet.
	 * @throws when my infomation history is empty.
	 */
	public HirommyPacket getMyInfo() throws NoSuchElementException {
		return (HirommyPacket)myInfoLists.removeFirst();
	}
	
	/**
	 * @return Returns the myInfoLists.
	 */
	public LinkedList getMyInfoLists() {
		return myInfoLists;
	}
	
	/**
	 * @param myInfoLists The myInfoLists to set.
	 */
	public void setMyInfoLists(LinkedList myInfoLists) {
		this.myInfoLists = myInfoLists;
	}
	
	/**
	 * @return Returns the targetTerminalLists.
	 */
	public LinkedList getTargetInfoLists() {
		return targetInfoLists;
	}
	/**
	 * @param targetInfoLists The targetTerminalLists to set.
	 */
	public void setTargetInfoLists(LinkedList targetInfoLists) {
		this.targetInfoLists = targetInfoLists;
	}
	/**
	 * This method is for getting instance of this only onject.
	 * 
	 * @return instance of this class.
	 */
	public static RealDataSource getInstance() {
		return realDataSource;
	}
	
	/**
	 * clear this object data.
	 *
	 */
	public void flush() {
		myInfoLists.clear();
		targetInfoLists.clear();
	}
	/**
	 * This method set RealDataSource.
	 * 
	 * @param realDataSource The realDataSource to set.
	 */
	public static void setRealDataSource(RealDataSource realDataSource) {
		RealDataSource.realDataSource = realDataSource;
	}
}
