/*
 * Created on 2004/09/01
 *
 */
package jnet.hirommy.sim;

import java.util.Iterator;
import java.util.NoSuchElementException;

import jnet.hirommy.info.HirommyPacket;
import jnet.hirommy.util.InfoLogger;
import jnet.hirommy.util.SimulatinViewerHandlerImpl;
import jnet.hirommy.util.ViewerHandler;

/**
 * This is reprecents virtual network.
 * 
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public class VirtualNetwork implements Runnable {
	
	/**
	 * Simulation Speed.
	 * for example, 1000 is real time. 100 is ten real time.
	 */
	private static int simSpeed = 1000;
	
	/**
	 * true:my infomation isn't empty. false: empty.
	 */
	private static boolean flag = true;
	
	/**
	 * This method is for starting simulation.<br>
	 * 
	 * 1 : My HirommyPacket is taken out and it saves at a log.<br>
	 * 2 : HirommyPacket of a taret terminal
	 * thart The value of the time field of the taken-out packet is same 
	 * is taken out. <br>
	 * 3 : It saves at a log. <br>
	 * 
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		
		System.out.println("Simulation is started");
		
		flag = true;
		
		// clear InfoLog.
		InfoLogger.getInstance().flash();
		
		while (flag) {
			
			// get RealDataSource instance.
			RealDataSource realDataSource = RealDataSource.getInstance();
			
			// my hirommy packet.
			HirommyPacket myInfo = null;
			
			try {
				// get my infomation.
				myInfo = realDataSource.getMyInfo();
				// log my infomation.
				InfoLogger.getInstance().logMyHirommyPacket(myInfo);
				System.out.println("Logging my infomation");
			} catch (NoSuchElementException e) {
				// if my infomation history is empty.
				flag = false;
				e.printStackTrace();
			}
			
			// get target terminal iterator.
			Iterator targetIterator = RealDataSource.getInstance().getTargetInfoLists().iterator();
			// log target Infomatin.
			while (targetIterator.hasNext()) {
				HirommyPacket targetPacket = (HirommyPacket)targetIterator.next();
				// get time of hirommy packet of terget.
				String time = targetPacket.getGpsInfo().getTime();
				
				if (myInfo.getGpsInfo().getTime().equals(time)) {
				// If there is the packet with the same value of the time field of my packet, 
				// packet of target terminal is saves at a log.
				InfoLogger.getInstance().logReceivedHirommyPacket(targetPacket);
				System.out.println("Logging target infomation");
				}
			}
			
			// update Viewer.
			ViewerHandler viewerHandler = new SimulatinViewerHandlerImpl();
			viewerHandler.repaintGpsViewer();
			
			// sleep.
			try {
				// sleep.
				Thread.sleep(simSpeed);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		}
		
		System.out.println("Simulation is ended.");
	}

	/**
	 * This method ended simulatin.
	 * 
	 */
	public static void close() {
		flag = false;
	}
	/**
	 * @param simSpeed The simSpeed to set.
	 */
	public static void setSimSpeed(int simSpeed) {
		VirtualNetwork.simSpeed = simSpeed;
	}
}
