/*
 * Created on 2004/08/29
 *
 */
package jnet.its.gps;

import java.util.LinkedList;

import jnet.hirommy.info.GpsInfo;

/**
 * This is interface of calculating headding.
 * 
 * @author Kazuya Sakai
 * @version 1.0
 * @since jdk 1.4.2
 */
public interface HeaddingCalculator {
	/**
	 * The method for calculating headding.
	 * 
	 * @return headding
	 */
	public abstract String calculateHeadding(LinkedList lists, GpsInfo currentGpsInfo);
	
	/**
	 * This method returns direction name.
	 * for example, if 337.5 - 0.0 and 0.0 - 22.5, 
	 * direction name is "NORTH".
	 * 
	 * @param headding headding CompassDegree
	 * @return name of direction.
	 */
	public abstract String getHeddingName(String headding);
}
