/*
 * Created on 2004/08/29
 *
 */
package jnet.its.gps;

import java.util.LinkedList;

import jnet.hirommy.info.GpsInfo;
import jnet.hirommy.info.HirommyPacket;
import jnet.hirommy.util.DistanceCalculater;

/**
 * This is a class which realizes a simple speed calculation method.
 * 
 * @author Kazuya Sakai
 * @version 1.0
 * @since jdk 1.4.2
 */
public class SimpleSpeedCalculationMethod implements SpeedCalculator {

	/**
	 * This is a simple speed calculation method
	 * 
	 * @param lists Sauce information for calculation speed
	 * @param currentGpsInfo lately GpsInfomation.
	 * @return speed
	 * @see jnet.its.gps.SpeedCalculator#calculateSpeed(java.util.LinkedList, jnet.hiromy.info.GpsInfo)
	 */
	public String calculateSpeed(LinkedList lists, GpsInfo currentGpsInfo) {
		
		if (lists.size() >= 2) {
			// The last element is taken out.
			// / The GPS information of 1 second ago is taken out.
			GpsInfo exGpsInfo = ((HirommyPacket)lists.getLast()).getGpsInfo();
			
			// calculate the distance of present and 1 second ago.
			double d = DistanceCalculater.getDistance(currentGpsInfo.getLatitude(),
													   currentGpsInfo.getLongitude(),
													   exGpsInfo.getLatitude(),
													   exGpsInfo.getLongitude());
			// The unit of Variable d is (m/s).
			// transfor from m/s to km/h.
			d = d * 3600 / 1000;
			
			return String.valueOf(d);
			
		} else {	// When there is no GPS information for calculating speed.
			return null;
		}
	}

}
