/*
 * Created on 2004/09/06
 *
 */
package jnet.its.ivc.reaction;

import jnet.hirommy.info.HirommyPacket;

/**
 * This is interface that reaction algorithm.
 * 
 * @author Kazuya Sakai
 * @version 2.0
 * @since jdk 1.4.2
 */
public interface ReactionAlgorithm {
	/**
	 * This method investigates whether the target terminal is contained in the reaction domain.
	 * 
	 * @param myHirommyPacket my hirommy packet
	 * @param targetHirommyPacket target hirommy packet
	 */
	public abstract boolean isReact(HirommyPacket myHirommyPacket, HirommyPacket targetHirommyPacket);
	
	/**
	 * This method is for setting reactin radius.
	 * 
	 * @param radius reaction radius.
	 */
	public abstract void setReactionRadius(double radius);
}
